'''
Created on Jul 23, 2019 @author: levente.marton
'''

import os
from time import sleep
from datetime import datetime
from datetime import date
from collections import deque

from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support import ui as sui
from selenium.webdriver.common.alert import Alert
from selenium.webdriver.common.by import By
from rich.console import Console

from pybank._remotebank import RemoteBank
from pybank._exceptions import no_element_exceptions, all_element_exceptions, safety_timeout_exc
from pybank import mailer
from pybank.btrl_logger import extras_logger_btrl
from pybank.btrl_logger import balance_logger_btrl

def print(*objects, end: str="\n"):
    console = Console()
    console.print(*objects, style='yellow', end=end)


letter = mailer.mailer_details(mail_to=mailer.TO, mail_from=mailer.FR_ADDR, mail_subj=mailer.SUBJ)

xpaths = {'url': 'https://ib.btrl.ro/BT24/bfo/channel/web/loginframe.jsp?locale=RO',
          'el_us': '$$LoginId$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
          'el_pw': '$$AuthToken$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedLoginRequest',
          'atp': os.getenv('BTRLIB'),
          'el_otp': '$$OTPToken$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedValidatingOTPRequest$$bfo_46_channel_46_web_46_function_46_login_58_UnencodedValidatingOTPRequest',
          'login': 'N51904ML',  # 'N63584PA'
          'refresh': 'balancerefresh_ron_link',
          'd_name': 'BT',
          'client': '//*[@id="button4"]/span',
          'extr': '26603_link',
          'summary_but': '//*[@id="export"]/span[2]',
          'extr_account': 'linkLabelVisited',
          'extr_pdf': './/*[@id="export2"]',
          'extr_dl': '//*[@id="export"]/span[2]',
          'home': 'image_close',
          'exp_but': '//*[@id="export"]/span[2]',
          'extr_period': '//*[@id="$$NumberLimitation_47_Range_47_FromDate$$bfo_46_function_46_accounthistory_58_AccountHistoryRequest$$bfo_46_function_46_accounthistory_58_AccountHistoryRequest"]',
          'search_but': '//*[@id="search"]/span[2]',
          'sold': '//*[@id="ronBalanceOnline"]'
          }

class Bank(RemoteBank):
    '''
    classdocs
    '''
    def __init__(self):
        '''
        Constructor
        '''
        super().__init__()

    def bank_login(self, passw=None):
        self.switch_to.window(self.window_handles[0])
        self.get(xpaths['url'])
        print('...bank url is %s' % (xpaths['url'])); sleep(1)
        try:
            sleep(5)  # original is 15
            bt_iframe = self.find_elements(By.TAG_NAME, 'iframe')[0]
            self.switch_to.frame(bt_iframe); sleep(1.5)
            user = self.find_element(By.ID, xpaths['el_us'])
            user.send_keys(xpaths['login']); sleep(1.5)
            passv = self.find_element(By.ID, xpaths['el_pw'])
            passv.send_keys(xpaths['atp']); sleep(1.5)
            # passv.send_keys(input('...token pass here'))
            passv.send_keys(Keys.RETURN); sleep(1.5)
            otp = self.find_element(By.ID, xpaths['el_otp'])
            otp.send_keys(input('...token pass/OTP here'))
            otp.send_keys(Keys.RETURN); sleep(1.5)
            self.switch_to.default_content(); sleep(1.5)
            client_iframe = self.find_elements(By.TAG_NAME, 'iframe')[0]
            self.switch_to.frame(client_iframe)
            client = self.find_element(By.XPATH, xpaths['client'])
            client.click(); sleep(1.5)
            # bt_iframe = self.find_elements(By.TAG_NAME, 'iframe')[0]
            # self.switch_to.frame(bt_iframe); sleep(1.5)
            self.switch_to.default_content()
        except no_element_exceptions:  # NoSuchElementException:
            user = self.find_element(By.ID, xpaths['el_us'])
            user.send_keys(xpaths['login']); sleep(1.5)
            passv = self.find_element(By.ID, xpaths['el_pw'])
            passv.send_keys(xpaths['atp']); sleep(1.5)
            # passv.send_keys(input('...token pass here'))
            passv.send_keys(Keys.RETURN); sleep(1.5)
            otp = self.find_element(By.ID, xpaths['el_otp'])
            otp.send_keys(input('...token pass/OTP here'))
            otp.send_keys(Keys.RETURN); sleep(3)
            self.switch_to.default_content(); sleep(1.5)
            client_iframe = self.find_elements(By.TAG_NAME, 'iframe')[0]
            self.switch_to.frame(client_iframe)
            client = self.find_element(By.XPATH, xpaths['client'])
            client.click(); sleep(1.5)
            self.switch_to.default_content()

    def _extras_dl(self, balance):
        print('verifying statements'); sleep(1)
        with open(self.statement_folder) as log_file:
            if len(os.listdir('pybank/extrase')) < 1:
                print('folder is empty')
            else:
                pass
            lines = log_file.readlines()
            if len(lines) < 1:
                print('file is empty')
            else:
                print('files were found', lines[-1][:10])
            if datetime.now().hour > 17 and lines[-1][:10] != str(datetime.now().date()):
                sleep(2)
                extr = sui.WebDriverWait(self, 5).until(lambda browser: browser.find_elements(By.ID, xpaths['extr'])[0])  # browser.find_element(By.ID, '26603_link')
                extr.click(); sleep(1)
                self.switch_to.default_content()
                page_iframe = self.find_elements(By.TAG_NAME, 'iframe')[1]
                self.switch_to.frame(page_iframe); sleep(0.5)
                summary_but = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['summary_but']))
                summary_but.click(); sleep(1)
                extr_account = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_elements(By.CLASS_NAME, xpaths['extr_account'])[1])
                sleep(0.5)
                extr_account.click(); sleep(10)
                extr_pdf = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['extr_pdf']))  # './/*[@id="download_1"]/span'
                extr_pdf.click(); sleep(0.5)
                extr_dl = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['extr_dl']))
                extr_dl.click(); sleep(1)
                self.switch_to.default_content()
                _home = self.find_elements(By.CLASS_NAME, xpaths['home'])[1]  # //*[@id="page1542644222340693_close_img"]
                _home.click(); sleep(0.5)
                print('statement downloaded')
                extras_logger_btrl.info(balance)
            else:
                print('skipping statement'); sleep(2)

    def _extras_summary(self):
        # sleep(2)
        # bt_iframe2 = self.find_elements(By.TAG_NAME, 'iframe')[0]
        # self.switch_to.frame(bt_iframe2)
        # extr = sui.WebDriverWait(self, 5).until(lambda browser: browser.find_elements(By.ID, '26603_link')[0])  # browser.find_element(By.ID, '26603_link')
        # extr.click(); sleep(1)
        # self.switch_to.default_content()
        # page_iframe = self.find_elements(By.TAG_NAME, 'iframe')[1]
        # self.switch_to.frame(page_iframe); sleep(0.5)
        summary_but = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['summary_but']))
        summary_but.click(); sleep(1)
        # extr_account = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'linkLabelVisited')[1])
        # sleep(0.5)
        # extr_account.click(); sleep(10)
        # extr_pdf = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, './/*[@id="export2"]'))  # './/*[@id="download_1"]/span'
        # extr_pdf.click(); sleep(0.5)
        # extr_dl = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, '//*[@id="export"]/span[2]'))
        # extr_dl.click(); sleep(1)
        # self.switch_to.default_content()
        # _home = self.find_elements(By.CLASS_NAME, 'image_close')[1]  # //*[@id="page1542644222340693_close_img"]
        # _home.click(); sleep(0.5)
        # print('statement downloaded')
        # extras_logger_btrl.info(balance)
            # else:
            #     print('skipping statement'); sleep(2)

    def _export_csv(self):
        # # copied From trans screenshot only for testing
        # sleep(3)
        # bt_iframe2 = self.find_elements(By.TAG_NAME, 'iframe')[0]
        # self.switch_to.frame(bt_iframe2)
        # extr = sui.WebDriverWait(self, 5).until(lambda browser: browser.find_elements(By.ID, '26603_link')[0])
        # extr.click(); sleep(1)
        # self.switch_to.default_content()
        # page_iframe = self.find_elements(By.TAG_NAME, 'iframe')[1]
        # self.switch_to.frame(page_iframe); sleep(1)
        # extr_account = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'linkLabelVisited')[1])
        # sleep(0.5)
        # extr_account.click(); sleep(10)
        # extr_pdf = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, '//*[@id="$$NumberLimitation_47_Range_47_FromDate$$bfo_46_function_46_accounthistory_58_AccountHistoryRequest$$bfo_46_function_46_accounthistory_58_AccountHistoryRequest"]'))  # './/*[@id="download_1"]/span'
        # start_period = date.today().strftime('%d.%m.%Y')
        # extr_pdf.send_keys(Keys.CONTROL + 'a'); sleep(0.5)
        # extr_pdf.send_keys(start_period); sleep(0.5)
        # extr_pdf.send_keys(Keys.TAB); sleep(0.5)
        # extr_dl = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, '//*[@id="search"]/span[2]'))
        # extr_dl.click(); sleep(5)
        # # End peese from trans screenshot
        exp_but = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['exp_but']))
        exp_but.click(); sleep(1)
        alert = Alert(self)
        alert.accept()

    def _transaction_screenshot(self):
        ops = []
        sleep(3)
        # bt_iframe = self.find_elements(By.TAG_NAME, 'iframe')[0]
        # self.switch_to.frame(bt_iframe); sleep(2)
        extr = sui.WebDriverWait(self, 5).until(lambda browser: browser.find_elements(By.ID, xpaths['extr'])[0])
        extr.click(); sleep(1)
        self.switch_to.default_content()
        page_iframe = self.find_elements(By.TAG_NAME, 'iframe')[1]
        self.switch_to.frame(page_iframe); sleep(1)
        extr_account = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_elements(By.CLASS_NAME, xpaths['extr_account'])[1])
        sleep(0.5)
        extr_account.click(); sleep(10)
        extr_period = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['extr_period']))  # './/*[@id="download_1"]/span'
        start_period = date.today().strftime('%d.%m.%Y')
        extr_period.send_keys(Keys.CONTROL + 'a'); sleep(0.5)
        extr_period.send_keys(start_period); sleep(0.5)
        extr_period.send_keys(Keys.TAB); sleep(0.5)
        search_but = sui.WebDriverWait(self, 15).until(lambda browser: browser.find_element(By.XPATH, xpaths['search_but']))
        search_but.click(); sleep(5)
        try:
            transaction0 = sui.WebDriverWait(self, 4).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'row_0'))
        except safety_timeout_exc:  # TimeoutException:
            transaction0 = []
        transaction1 = sui.WebDriverWait(self, 4).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'row_1'))
        # if len(transaction0) == len(transaction1):
        #     transaction = sui.WebDriverWait(self, 4).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'row_0')[-1])
        # else:
        #     transaction = sui.WebDriverWait(self, 4).until(lambda browser: browser.find_elements(By.CLASS_NAME, 'row_1')[-1])
        if len(transaction0) >= len(transaction1):
            for i in range(len(transaction0)):
                try:
                    empl = mailer.re_check(transaction1[i].text)
                    if empl not in self.employees:
                        ops.append(transaction1[i].text[21:])
                except IndexError:
                    pass
                empl = mailer.re_check(transaction0[i].text)
                if empl not in self.employees:
                    ops.append(transaction0[i].text[21:])
        else:
            for i in range(len(transaction1)):
                empl = mailer.re_check(transaction1[i].text)
                if empl not in self.employees:
                    ops.append(transaction1[i].text[21:])
                try:
                    empl = mailer.re_check(transaction0[i].text)
                    if empl not in self.employees:
                        ops.append(transaction0[i].text[21:])
                except IndexError:
                    pass
        if len(ops) < 1:
            ops.append(-1)
        ops = list(reversed(ops))
        self.transaction = mailer.Transactions(ops)
        self._export_csv()
        print('csv exported', end='\n')
        sleep(1)
        self.switch_to.default_content()
        _home = self.find_elements(By.CLASS_NAME, xpaths['home'])[1]  # //*[@id="page1542644222340693_close_img"]
        _home.click(); sleep(0.5)
        return self.transaction

    def refresh(self):
        c = 1
        err = 1; sleep(3)
        # self.switch_to.default_content()
        bt_iframe2 = self.find_elements(By.TAG_NAME, 'iframe')[0]
        self.switch_to.frame(bt_iframe2)
        bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element(By.ID, xpaths['refresh']))
        print(bal.get_attribute('id'))
        self.sold_cont = deque(maxlen=2)
        logback = False
        first_start = True
        while True:
            # self.transaction = 'Confidential content'
            try:
                t = 210; sleep(3)
                print(xpaths['d_name'])
                with open('pybank/extrase/BTRL.log') as statement:
                    if first_start:
                        sold = mailer.dig_it(statement.readlines()[-1][11:])
                        self.sold = sold
                        if logback is False or len(self.sold_cont) < 2:
                            self.sold_cont.appendleft(sold)
                            print(type(self.sold_cont[0]), self.sold_cont[0])
                    else:
                        sold = self.find_element(By.XPATH, xpaths['sold'])
                        self.sold = sold.text
                        if logback is False or len(self.sold_cont) < 2:
                            self.sold_cont.appendleft(sold.text)
                logback = False
                try:
                    self._extras_dl(self.sold_cont[0])
                    bal.click(); sleep(2)
                except all_element_exceptions:
                    print('...skipping')
                if isinstance(mailer.dig_it(self.sold_cont[0], self.sold_cont[0]), float):
                    print('...prev balance: {}'.format(mailer.dig_it(self.sold_cont[0], self.sold_cont[0])))
                else:
                    bal.click()
                    sold = self.find_element(By.XPATH, xpaths['sold'])
                    self.sold_cont.appendleft(sold.text)
                while t >= 0:
                    mins, secs = divmod(t, 60)
                    timeformat = '{:02d}:{:02d}'.format(mins, secs)
                    print('...clicking in', timeformat, end='\r'); sleep(1)
                    t -= 1
                print('')
                print('...now clicking')
                bal.click(); sleep(3)
                sold1 = self.find_element(By.XPATH, xpaths['sold'])
                print('')
                try:
                    sleep(0.5)
                    if isinstance(mailer.dig_it(sold1.text, self.sold_cont[0]), float):
                        print('...new balance: {0}'.format(mailer.dig_it(sold1.text, self.sold_cont[0])))
                except ValueError:
                    sleep(1)
                    try:
                        if isinstance(mailer.dig_it(sold1, self.sold_cont[0]), float):
                            print('...new balance2: {0}'.format(mailer.dig_it(sold1, self.sold_cont[0])))
                    except TypeError:
                        print('...{0}'.format(mailer.dig_it(sold1.text, self.sold_cont[0])))
                # try:
                print('1`st try')
                to_send = mailer.dig_it(sold1.text, self.sold_cont[0]) - mailer.dig_it(self.sold_cont[0], self.sold_cont[0])
                if to_send != 0:
                    if sold1 == '':
                        print('reinitiate sold')
                    else:
                        if isinstance(mailer.dig_it(sold1.text, self.sold_cont[0]), float):
                            balance_logger_btrl.info('{:.2f}'.format(mailer.dig_it(sold1.text, self.sold_cont[0])))
                            print('balance logged')
                            # if to_send > 0:
                            self._transaction_screenshot()
                            letter._subject = xpaths['d_name'] + ' ' + mailer.SUBJ + \
                                ' {0:2d}:{1:2d}:{2:2d}'.format(datetime.now().time().hour, datetime.now().time().minute, datetime.now().time().second)
                            letter.add_to_text_body(
                                'You`r receiving this mail because of a bank account event.\n\n \
                                Bank name: {0}\nTransaction details: {1}\n\nMozaik Consulting\nfinancial department\n\n{2}\n\n{3}'.format(
                                    xpaths['d_name'], round(to_send, 2), datetime.now().time(), repr(self.transaction)))
                            # letter.send(mailer.S_NAME, mailer.P_NUM, mailer.LOG_U, mailer.PAS, mailer.SEC)
                            print('notification sent, diff: {0}'.format(to_send))
                            # balance_logger_btrl.info('{:.2f}'.format(mailer.dig_it(sold1.text, self.sold_cont[0])))
                            # print('balance logged')
                else:
                    if isinstance(mailer.dig_it(sold1.text, self.sold_cont[0]), float):
                        print('...balance not changed, diff: {0}'.format(to_send))
                        balance_logger_btrl.info('{:.2f}'.format(mailer.dig_it(sold1.text, self.sold_cont[0])))
                        print('balance logged')
                print('...clicked {0} times'.format(c))
                c += 1
            except all_element_exceptions:
                print('...element lost %s times, waiting to return' % (err))
                if err > 1:
                    logback = True
                try:
                    # self.switch_to.default_content()
                    bt_iframe = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_elements(By.TAG_NAME, 'iframe')[0])  # browser.find_elements(By.TAG_NAME, 'iframe')[0]
                    self.switch_to.frame(bt_iframe)
                    bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element(By.ID, xpaths['refresh']))
                    sold = self.find_element(By.XPATH, xpaths['sold'])
                    self.sold = sold.text
                    # if logback is False or len(self.sold_cont) < 2:
                    # self.sold_cont.appendleft(sold.text)
                    # self.switch_to.default_content()
                except Exception as _:
                    print(str(_))
                    try:
                        bal = sui.WebDriverWait(self, 10).until(lambda browser: browser.find_element(By.ID, xpaths['refresh']))
                        sold = self.find_element(By.XPATH, xpaths['sold'])
                        self.sold = sold.text
                    except safety_timeout_exc:
                        sleep(10)
                        self.bank_login()
                        logback = True
                err += 1
            # first_start = False
