'''Created 18 Jan 2023 Levi'''

import datetime
import pickle
import os
from google_auth_oauthlib.flow import Flow, InstalledAppFlow
from google.auth.transport.requests import Request
from google.oauth2.credentials import Credentials
from googleapiclient.discovery import build
from oauth2client.service_account import ServiceAccountCredentials
from apiclient.discovery import build
from httplib2 import Http

def create_service(client_secret, api_name, api_version, *scopes):
    CLIENT_SECRET_FILE = client_secret
    API_SERVICE_NAME = api_name
    API_VERSION= api_version
    SCOPES = [scope for scope in scopes[0]]
    print(SCOPES)
    cred = None
    home = os.path.expanduser('~')
    pickle_file = f'token_{API_SERVICE_NAME}_{API_VERSION}.pickle'
    pickle_file = os.path.join(home, '.credentials', pickle_file)
    # print(pickle_file)
    if os.path.exists(pickle_file):
        with open(pickle_file, 'rb') as token:
            cred = pickle.load(token)
    if not cred or not cred.valid:
        if cred and cred.expired and cred.refresh_token:
            cred.refresh(Request())
        else:
            flow = InstalledAppFlow.from_client_secrets_file(client_secrets_file=CLIENT_SECRET_FILE,
                                                             scopes=SCOPES)
            # InstalledAppFlow.run
            cred = flow.run_local_server(port=8090)
        with open(pickle_file, 'wb') as token:
            pickle.dump(cred, token)
    
    try:
        service = build(serviceName=API_SERVICE_NAME,
                        version=API_VERSION,
                        credentials=cred)
        print(API_SERVICE_NAME, 'service created succesfully')
        return service
    except Exception as exc_:
        print(exc_)
        print(f'failed to create service instance for {API_SERVICE_NAME}')


# SCOPES = ["https://www.googleapis.com/auth/chat.memberships.app"]
SCOPES = ['https://www.googleapis.com/auth/chat.bot']

def main():
    '''
    Authenticates with Chat API via user credentials,
    then adds the Chat app to a Chat space.
    '''

    # Start with no credentials.
    creds = None

    # Check for the file token.json. If it exists, use it for authentication.
    # The file token.json stores the user's access and refresh tokens, and is
    # created automatically when the authorization flow completes for the first
    # time.
    home = os.path.expanduser('~')
    pickle_file = os.path.join(home, '.credentials', 'token.json')
    if os.path.exists(pickle_file):
        creds = Credentials.from_authorized_user_file(os.path.join(home, '.credentials', 'token.json'), SCOPES)

    # If there are no valid credentials available, let the user log in.
    if not creds or not creds.valid:
        if creds and creds.expired and creds.refresh_token:
            creds.refresh(Request())
        else:
            flow = InstalledAppFlow.from_client_secrets_file(
                os.path.join(home, '.credentials', 'client_secret_mzk.json'), SCOPES)
            creds = flow.run_local_server(port=0)

        # Save the credentials for the next run in a file
        # named token.json.
        with open(os.path.join(home, '.credentials', 'token.json'), 'w') as token:
            token.write(creds.to_json())

    # Build a service endpoint for Chat API.
    service = build('chat', 'v1', credentials=creds)

    # Set the Chat app as the entity that gets added to the space.
    # 'app' is an alias for the Chat app running the script.
    #
    # To specify a user, set:
    #
    # member = {
    #   'member': {
    #     'name':'users/{user}',
    #     'type':'HUMAN'
    #   }
    # }
    member = {
      'member': {
        'name':'users/app',
        'type': 'BOT'
      }
    }

    # Use the service endpoint to call Chat API.
    result = service.spaces().members().create(

      # Replace {space} with a space name.
      # Obtain the space name from the spaces resource of Chat API,
      # or from a space's URL.
      parent='spaces/AGA MZK',
        body=member).execute()

    # Prints details about the created membership.
    print(result)

if __name__ == '__main__':
    home = os.path.expanduser('~')
    #
    # CREDENTIALS = ServiceAccountCredentials.from_json_keyfile_name(
    # os.path.join(home, '.credentials', 'tasks-375117-a325dcfa11bb.json'), SCOPES)
    # chat = build('chat', 'v1', http=CREDENTIALS.authorize(Http()))
    # result = chat.spaces().messages().create(
    #
    # # The space to create the message in.
    # #
    # # Replace SPACE_NAME with a space name.
    # # Obtain the space name from the spaces resource of Chat API,
    # # or from a space's URL.
    # parent='spaces/AGA MZK',
    #
    # # The message to create.
    # body={'text': 'Hello, world!'}
    #
    # ).execute()
    # result = chat.spaces().list().execute()
    CLIENT_SECRET_FILE = os.path.join(os.path.expanduser('~'), '.credentials', 'client_secret_mzk.json')
    # print(CLIENT_SECRET_FILE)
    API_NAME = 'chat'
    API_VERSION = 'v1'
    # main()
    SCOPES = ['https://www.googleapis.com/auth/chat.spaces']
    # CREDENTIALS = ServiceAccountCredentials.from_json_keyfile_name(os.path.join(os.path.expanduser('~'), '.credentials', 'pysheet26134-f16afc2d28e6.json'), SCOPES)
    service = create_service(CLIENT_SECRET_FILE, API_NAME, API_VERSION, SCOPES)
    # chat = build('chat', 'v1', http=CREDENTIALS.authorize(Http()))
    # print(chat.spaces().list().execute())
    # print(dir(service))
    print(service.spaces().list().execute())
